#! python

# On peut dsormais tracer des droites et des cercles
# Et on les voit tous deux se tracer...

from Tkinter import *
from math import *

class Test(Frame):
	def __init__(self, master=None):
		Frame.__init__(self,master)
		Pack.config(self)
		self.createFeuille()
		self.createBoutonPourPartir()
		self.createBoutonsPourChoisir()
		self.OnTraceUneDroite()
		
		self.p0_x = self.p0_y = self.p1_x =self.p1_y = None
		self.rubber_object = None

	### La planche  dessin
	def createFeuille(self):
		self.feuille = Canvas(self, 
				      {"width": "20c", 
				       "height": "20c"})
		self.feuille.create_polygon("0c", "0c",
					    "1c", "0c",
					    "1c", "1c", 
					    "0.5c", "1.5c",
					    "0c", "1c")
		self.feuille.create_line("2c", "2c", "0c", "5c")
		self.feuille.create_oval("2c", "2c", "3c", "3c")
		self.feuille.pack({"side": "right"})
		
	### Les diffrentes choses que l'on peut tracer

	def createBoutonsPourChoisir(self):
		self.choix_droite = Button(self, 
				    {"text": "Droite",
				     "command": self.OnTraceUneDroite,
				     "activebackground": "red"})
		self.choix_droite.pack({"side":"top"})
		self.choix_cercle = Button(self, 
				    {"text": "Cercle",
				     "command": self.OnTraceUnCercle,
				     "activebackground": "red"})
		self.choix_cercle.pack({"side":"top"})

	def createBoutonPourPartir(self):
		self.bouton_pour_partir = Button(self, 
						 {"text": "Au revoir",
						  "command": self.quit})
		self.bouton_pour_partir.pack({"side": "bottom"})
		
      	### une droite
	def OnTraceUneDroite(self):
		Widget.bind(self.feuille, "<1>", self.ligne_premierPoint)
		Widget.bind(self.feuille, "<2>", self.ligne_deuxiemePoint)
		Widget.bind(self.feuille, "<3>", self.ligne_dernierPoint)

	def ligne_premierPoint(self,event): 
		self.p0_x = self.p1_x = event.x
		self.p0_y = self.p1_y = event.y
		Widget.bind(self.feuille, "<Motion>", self.line_motion)

	def ligne_deuxiemePoint(self,event):
		if self.p1_x == None:
			return
		self.feuille.create_line(self.p1_x, self.p1_y, event.x, event.y)
		self.p1_x = event.x
		self.p1_y = event.y
		self.rubber_object = None

	def ligne_dernierPoint(self,event):
		if self.p1_x == None:
			return
		self.feuille.create_line(self.p1_x, self.p1_y, event.x, event.y)
		self.feuille.create_line(self.p0_x, self.p0_y, event.x, event.y)
		self.p1_x = None
		self.p1_y = None
		Widget.bind(self.feuille, "<Motion>", do_nothing) ##### TRS LENT...
		self.rubber_object = None

	def line_motion(self,event):
		self.feuille.delete(self.rubber_object)
		self.rubber_object = self.feuille.create_line(self.p1_x, self.p1_y, event.x, event.y)

	### Un cercle
	def OnTraceUnCercle(self):
		Widget.bind(self.feuille, "<1>", self.cercle_centre)
		Widget.bind(self.feuille, "<2>", self.cercle_point)
		Widget.bind(self.feuille, "<3>", self.cercle_fini)


		
	def cercle_centre(self,event):
		self.p0_x = event.x
		self.p0_y = event.y
		Widget.bind(self.feuille, "<Motion>", self.cercle_motion)
		
	def cercle_point(self,event):
		distance = sqrt((self.p0_x-event.x)*(self.p0_x-event.x)+
				(self.p0_y-event.y)*(self.p0_y-event.y))
		self.feuille.create_oval(self.p0_x-distance, self.p0_y-distance,
					 self.p0_x+distance, self.p0_y+distance)
		self.rubber_object = None

	def cercle_fini(self,event):
		self.feuille.delete(self.rubber_object)
		self.rubber_object = None
		Widget.bind(self.feuille, "<Motion>", do_nothing) ##### TRS LENT...


	def cercle_motion(self, event):
		distance = sqrt((self.p0_x-event.x)*(self.p0_x-event.x)+
				(self.p0_y-event.y)*(self.p0_y-event.y))
		self.feuille.delete(self.rubber_object)
		self.rubber_object = self.feuille.create_oval(self.p0_x-distance, self.p0_y-distance, self.p0_x+distance, self.p0_y+distance)

def do_nothing(a=None, b=None):
	pass

test = Test()
test.master.title("Ceci est un essai")
test.mainloop()
