
##
## Calculs
##

def solution_systeme(a,b,c,d,e,f):
	D = a*e - d*b
	if zero(D):
		raise Erreur("Systeme degenere")
	else:
		return ( (c*e - b*f) / D, (a*f - c*d) / D )


def solution_second_degre(a,b,c):
	a = a * 1.0
	b = b * 1.0
	c = c * 1.0
	if zero(a):
		if zero(b):
			raise Probleme("Elle est un peu dgnre ton quation du second degr !")
		else:
			x = -c/b
			return (x,x)
	else:
		d = 1.0*b*b - 4.0*a*c
#		print "d = ", d
		if d<0.0:
			raise Probleme("quation du second degr : pas de solution")
		else:
			x1 = (-b -math.sqrt(d))/(2*a)
			x2 = (-b +math.sqrt(d))/(2*a)
#			print x1, " ", a*x1*x1+b*x1+c
#			print x2, " ", a*x2*x2+b*x2+c
			return (x1, x2)

def dichotomie(f,a,b,e=epsilon):
	x = f(a)
	y = f(b)
	a = copy(a)
	b = copy(b)
	if x*y > 0:
		raise Probleme("Il n'y a pas de solution dans cet intervalle")
	else:
		c = copy(a)
		while abs(b-a) > e:
			c = (a+b)/2
			z = f(c)
			if f(c)*f(a) < 0:
				b,y = c,z
			else:
				a,x = c,z
		return c

def zero(a):
	global epsilon
	if type(a) == type(1.0) or type(a) == type(1):
		return abs(a)<epsilon
	elif CLASS(a, Vecteur):
		return zero(norme(a))
	else:
		raise Probleme("Je ne sais pas calculer la norme de", a.__class__)


##
## Calculs  caractre plus gomtrique
##

def produit_scalaire(u,v):
	return u.x*v.x + u.y*v.y

def norme(u):
	return math.sqrt(produit_scalaire(u,u))

# Ne permet pas de distinguer entre angles positifs et ngatifs.
def angle_vecteurs(u,v):
	if(zero(u) or zero(v)):
		raise Probleme( "L'un des vecteurs est nul")
	else:
		c = produit_scalaire(u,v)/(norme(u)*norme(v))
		theta = math.acos(c)
		if u.x*v.y-u.y*v.x < 0:
			theta = -theta
		return theta

def angle(a,b):
	return angle_vecteurs(a,b)

def distance_point_point(A,B):
	return math.sqrt((A.x-B.x)*(A.x-B.x)+(A.y-B.y)*(A.y-B.y))

def distance_point_droite(A,D):
	E = perpendiculaire(D,A)
	I = intersection(D,E)
	return distance(A,I)

def distance(a,b):
	if CLASS(a,Point) and CLASS(b,Point):
		return distance_point_point(a,b)
	elif CLASS(a,Point) and CLASS(b,Droite):
		return distance_point_droite(a,b)
	elif CLASS(a,Droite) and CLASS(b,Point):
		return distance_point_droite(b,a)
	else:
		raise JeNeSaisPas("calculer de distance", a.__class__, b.__class__)
