
##
## Quelques copnstructions non lmentaires mais classiques
##

## isobarycentre

def isobarycentre(A,B,C=Point(99999.71,99999.71)):
	if C.x==99999.71 and C.y==99999.71:
		return barycentre(A,1,B,1)
	else:
		return barycentre(A,1,B,1,C,1)

## Milieu de deux points, d'un segment ##########

def milieu(A,B):
	return isobarycentre(A,B)

## mediatrice de deux points, d'un segment ##########
##########

def mediatrice(A,B):
	return perpendiculaire(Droite(A,B), milieu(A,B))

## Orthocentre

def orthocentre(A,B,C):
	D  = perpendiculaire(Droite(A,B), C)
	E  = perpendiculaire(Droite(B,C), A)
	F  = perpendiculaire(Droite(C,A), B)
	H  = intersection(D,E)
	return H

## Centre du cercle circonscrit

def centre_du_cercle_circonscrit(A,B,C):
	A1 = milieu(B,C)
	B1 = milieu(C,A)
	C1 = milieu(A,B)
	D  = perpendiculaire(Droite(A,B), C1)
	E  = perpendiculaire(Droite(B,C), A1)
	F  = perpendiculaire(Droite(C,A), B1)
	O  = intersection(D,E)
	return O

def cercle_circonscrit(A,B,C):
	O = centre_du_cercle_circonscrit(A,B,C)
	return(Cercle(O, distance(A,O)))

## Cercles circonscrits externes
def cercles_circonscrits_externes_vieux(A,B,C):
	(A1,A2) = bissectrices(Droite(A,B),Droite(A,C))
	(B1,B2) = bissectrices(Droite(B,C),Droite(B,A))
	(C1,C2) = bissectrices(Droite(C,A),Droite(C,B))
	#######################
	#######################
	#######################  A FAIRE...
	#######################
	#######################
	CC = cercle_circonscrit(A,B,C)
	return(CC,CC,CC)

def cercle_circonscrit_externe(B,A,C):
	u = bissectrice(A, Vecteur(A,B), Vecteur(A,C))
	D1 = perpendiculaire(Droite(A,u),A)
	v = bissectrice(C, Vecteur(C,A), Vecteur(C,B))
	D2 = perpendiculaire(Droite(C,v),C)
	I = intersection(D1,D2)
	return Cercle(I, distance(I, Droite(A,C)))
		      
	
def cercles_circonscrits_externes(A,B,C):
	return( cercle_circonscrit_externe(A,B,C),
		cercle_circonscrit_externe(B,C,A),
		cercle_circonscrit_externe(C,A,B))

## Centre du cercle inscrit
def centre_du_cercle_inscrit(A,B,C):
	u = bissectrice(A, Vecteur(A,B), Vecteur(A,C))
	v = bissectrice(B, Vecteur(B,A), Vecteur(B,C))
	D1 = Droite(u.P, u.Q)
	D2 = Droite(v.P, v.Q)
	return intersection(D1, D2)

