
##
## Quelques fonctions pour effectuer nos constructions gomtriques.
##

## Intersection

def intersection_droites(D, E):
	det = D.a * E.b - D.b * E.a
	if zero(det):
		raise Probleme( "Intersection: Droites paralleles ou confondues...")
	return Point((-E.b*D.c+D.b*E.c)/det, (E.a*D.c-D.a*E.c)/det)

def intersection_cercle_droite(C, D):
	if not(zero(D.b)):
		a = 1+(D.a/D.b)*(D.a/D.b)
		b = 2*(D.c/D.b+C.centre.y)*D.a/D.b-2*C.centre.x
		c = C.centre.x*C.centre.x + (D.c/D.b+C.centre.y)*(D.c/D.b+C.centre.y) - C.rayon*C.rayon
		# Un petit try: / expect: ?
		(x1, x2) = solution_second_degre(a,b,c)
		(y1, y2) = ( -(D.c+D.a*x1)/D.b , -(D.c+D.a*x2)/D.b )
		return( Point(x1,y1), Point(x2,y2) )
	else:
		x = -D.c/D.a
		a = 1
		b = -2*C.centre.y
		c = (x - C.centre.x)*(x - C.centre.x) +C.centre.y*C.centre.y - C.rayon*C.rayon
		(y1, y2) = solution_second_degre(a, b, c)
		return( Point(x,y1), Point(x,y2) )

def intersection_cercle_cercle_tres_complique(C1,C2):
	f = lambda t,C1=C1,C2=C2: C2.puissance(rotation(C1.centre, t, translation(Vecteur(Point(0,0),Point(0, C1.rayon)),C1.centre)))
	solution = []
	inc = 2*math.pi/367
	for t in map(lambda n, inc=inc: n*inc , range(0,367)):
#		print t, f(t)
		if f(t)*f(t-inc)<=0:
			solution.append(dichotomie(f,t,t-inc))
	if len(solution) == 0:
		raise Probleme("Les deux cercles ne se coupent pas")
	elif len(solution) == 1:
		rep1 = rotation(C1.centre, solution[0], translation(Vecteur(Point(0,0),Point(0, C1.rayon)),C1.centre))
		return( rep1, rep1 )
	else:
		rep1 = rotation(C1.centre, solution[0], translation(Vecteur(Point(0,0),Point(0, C1.rayon)),C1.centre))
		rep2 = rotation(C1.centre, solution[1], translation(Vecteur(Point(0,0),Point(0, C1.rayon)),C1.centre))
		return( rep1, rep2 )

def intersection_cercle_cercle(C1, C2):
	a = copy(C1.centre.x)
	b = copy(C1.centre.y)
	c = copy(C2.centre.x)
	d = copy(C2.centre.y)
	r = copy(C1.rayon)
	s = copy(C2.rayon)
	e = (r*r-s*s+c*c-a*a+d*d-b*b)/(2*(d-b))
	f = (c-a)/(d-b)
	aa = 1+f*f
	bb = 2*((b-e)*f-a)
	cc = a*a+(b-e)*(b-e) - r*r
	(x1, x2) = solution_second_degre(aa,bb,cc)
	y1 = e - f*x1
	y2 = e - f*x2
	return (Point(x1,y1), Point(x2,y2))

def intersection(D,E):
	if CLASS(D,Droite) and CLASS(E,Droite):
		return intersection_droites(D,E)
	elif CLASS(D,Droite) and CLASS(E,Cercle):
		return intersection_cercle_droite(E,D)
	elif CLASS(D,Cercle) and CLASS(E,Droite):
		return intersection_cercle_droite(D,E)
	elif CLASS(D,Cercle) and CLASS(E,Cercle):
		return intersection_cercle_cercle(D,E)
	else:
		raise JeNeSaisPas("calculer une intersection " + `D.__class__` + " " + `E.__class__`)

## Perpendiculaire

def perpendiculaire_droite_point(D,M):
	#return Droite(-D.b, D.a, D.b*M.x-D.a*M.y)
	DD = Droite(Point(0,0), Point(1,1))
	DD.a = -D.b
	DD.b = copy(D.a)
	DD.c = D.b*M.x-D.a*M.y
	return DD

def perpendiculaire(D,M):
	return perpendiculaire_droite_point(D,M)

def parallele(D, P):
	return perpendiculaire(perpendiculaire(D, P), P)

## Bissectrices

def bissectrices_vieux(D,E):
        A = intersection(D,E)
        C = Cercle(A,1)
        (D1,D2) = intersection(D,C)
        (E1,E2) = intersection(E,C)
        I1 = milieu(E1,D1)
        I2 = milieu(D1,E2)
        return(Droite(A,I1), Droite(A,I2))

# Il faudrait se mettre d'accord sur ce que ca renvoit...
# Une demi-droite ou un couple point-vecteur ou un vecteur ???
def bissectrice(A,u,v):
	t = angle(u,v)
	w = rotation(A,t/2.0,u)
	return(w)

def bissectrices(D,E):
	A = intersection(D,E)
	C = Cercle(A,1)
	(I,J) = intersection(C,D)
	(K,L) = intersection(C,E)
	u = bissectrice(A, Vecteur(A,I), Vecteur(A,K))
	D1 = Droite(u.P, u.Q)
	D2 = perpendiculaire(D1, A)
	return(D1,D2)

## Barycentre

def barycentre(A, a, B, b, C=Point(0,0), c=0, D=Point(0,0), d=0):
# -2+1+0+0 == 0 ?????
	if a+b+c+d == 0: # Je m'tais tromp, j'avais mis b  la place de d. Vrifier si a marche, maintenant...
#		print a,b,c,d,  a+b+c+d
		raise Probleme("Barycentre", "la somme des coefficients est nulle")
	x = (a*A.x + b*B.x + c*C.x + d*D.x)/(a+b+c+d)
	y = (a*A.y + b*B.y + c*C.y + d*D.y)/(a+b+c+d)
	return Point(x,y)

