##
## Les objets gomtriques que l'on manipule
##

######################################################################

class Point(OBJET, Coordonnees):
	def __init__(self,x=None,y=None):
		Coordonnees.__init__(self,x,y)
		OBJET.__init__(self)
	def trace(self, nom=None, position=None, style=None, couleur=None):
		OBJET.trace(self,nom, position, style, couleur)
		set_limits(self)
		ajoute_point(self)
	def trace_maintenant(self):
		[v,h] = self.position
		if self.style=="plein" or self.style == "epais" or self.style == "pais":
			latex( "\pscircle*[linecolor=%s](%f,%f){0.1}%%" %(self.color, self.x, self.y))
		elif self.style == "normal" or self.style == "fin":
			latex( "\pscircle*[linecolor=white](%f,%f){0.1}%%" %(self.x, self.y))
			latex( "\pscircle[linecolor=%s](%f,%f){0.1}%%" %(self.color,self.x, self.y))
		if self.nom != None and self.nom != "":
			latex( "\\rput{0}(%f,%f){$\\relax %s$}%%" % (self.x+0.5*h, self.y+0.5*v, self.nom))


######################################################################

## J'ai un peu mlang vecteur en gomtrie affine (ou vectorielle) et 
## vecteur en gomtrie diffrentielle (ou en mcanique), cad, un
## vecteur attach  un point

class Vecteur(OBJET, Coordonnees):
	def __init__(self,P=None, Q=None):
		OBJET.__init__(self)
		if P==None:
			P=Point()
			Q=Point()
		elif P==0 and Q==None:
			P=global_O
			Q=global_O
		elif P==global_O and Q==None: #QUESTION : '==' compare-t-il les valeurs ou les pointeurs ???
			Q=Point()
		elif is_numeric(P) and is_numeric(Q):
			Q=Point(P,Q)
			P=global_O
		elif CLASS(P,Point) and Q==None:
			Q=P
			P=copy(global_O)
		elif CLASS(P,Point) and CLASS(Q,Point):
			pass
		elif CLASS(P,Point) and CLASS(Q,Vecteur):
			Q = translation(Q,P)
		else:
			raise Probleme("Arguments du constructeur d'un point")
		Coordonnees.__init__(self, Q.x-P.x, Q.y-P.y)
		self.P = copy(P)
		self.Q = copy(Q)
	def trace(self, nom=None, position=None, style=None, couleur=None):
		OBJET.trace(self,nom, position, style, couleur)
		set_limits(self.P)
		set_limits(self.Q)
		latex( "\\psline[linecolor=%s,linestyle=%s,arrows=%s,linewidth=%s](%f,%f)(%f,%f)%%" % (self.color, linestyle(self.style), arrows(self.style), linewidth(self.style), self.P.x, self.P.y, self.Q.x, self.Q.y))
		[v,h] = self.position
		if self.nom != None and self.nom != "":
			latex( "\\rput{0}(%f,%f){$\\relax %s$}%%" % (self.Q.x+0.5*h, self.Q.y+0.5*v, self.nom))


######################################################################

class Droite(OBJET):
	""" On met l''equation sous la forme ax + by + c = 0 """
	def __init__( self, P=None, Q=None):
		OBJET.__init__(self)
		if P==None and Q==None:
			P=Point()
			Q=Point()
		elif CLASS(P,Point) and Q==None:
			Q=Point()
		elif CLASS(P,Vecteur) and Q==None:
			Q=P
			P=Point()
		if CLASS(P,Point) and CLASS(Q, Point):
			self.a = P.y - Q.y
			self.b = Q.x - P.x
			self.c = P.x * (Q.y-P.y) - P.y * (Q.x-P.x)
		elif CLASS(P, Point) and CLASS(Q,Vecteur):
			self.a = copy(Q.y)
			self.b = -Q.x
			self.c = -P.x*Q.y + P.y*Q.x
		else:
			raise Probleme(P.__class__, Q.__class__, Point().__class__)
			self.a = P.y - Q.y
			self.b = Q.x - P.x
			self.c = P.x * (Q.y-P.y) - P.y * (Q.x-P.x)
	def trace(self, nom=None, position=None, style=None, couleur=None):
		OBJET.trace(self, nom, position, style, couleur)
		ajoute_droite(self)
	def trace_maintenant(self):
		if self.b != 0:
			Segment(Point(XMIN, -(self.a*XMIN+self.c)/self.b),
				Point(XMAX, -(self.a*XMAX+self.c)/self.b)).trace({'postion': self.position, 'style':self.style, 'couleur':self.couleur})
		elif self.a != 0:
			Segment(Point(-(self.b*YMIN+self.c)/self.a, YMIN),
				Point(-(self.b*YMAX+self.c)/self.a, YMAX)).trace({'postion': self.position, 'style':self.style, 'couleur':self.couleur})
	def point(self):
		if(zero(self.a)):
			return Point(random(), -1.0*self.c/self.b)
		else:
			y = random()
			x = -(y*self.b+self.c)/self.a
			return Point(x,y)
	def vecteur_directeur(self):
		u = Vecteur(O, Point(-self.b, self.a))
		return Vecteur(self.point(), normalise_vecteur(u))

######################################################################

class Segment(OBJET):
	def __init__(self, P=None, Q=None):
		OBJET.__init__(self)
		if P==None and Q==None:
			P=Point()
			Q=Point()
		elif CLASS(P,Point) and Q==None:
			Q=Point()
		elif CLASS(P,Point) and CLASS(Q,Point):
			pass
		else:
			raise Probleme("Parametres du constructeur d'un segment")
		self.P = copy(P)
		self.Q = copy(Q)
	def trace(self, nom=None, position=None, style=None, couleur=None):
		OBJET.trace(self, nom, position, style, couleur)
		set_limits(self.P)
		set_limits(self.Q)
		latex( "\\psline[linecolor=%s,linestyle=%s,linewidth=%s](%f,%f)(%f,%f)%%" % (self.color, linestyle(self.style), linewidth(self.style), self.P.x, self.P.y, self.Q.x, self.Q.y))
		[v,h] = self.position
		if self.nom != None and self.nom != "":
			latex( "\\rput{0}(%f,%f){$\\relax %s$}%%" % (self.Q.x+0.5*h, self.Q.y+0.5*v, self.nom))

######################################################################

class Cercle(OBJET):
	def __init__(self, a=None, b=None):
		OBJET.__init__(self)
		if a==None and b==None:
			P=Point()
			r=random()
		elif (type(a) is IntType or type(a) is LongType or type(a) is FloatType) and b==None:
			r=a
			P=Point()
		elif CLASS(a,Point) and b==None:
			P=a
			r=random()
		elif CLASS(a,Point) and (type(b) is IntType or type(b) is LongType or type(b) is FloatType):
			P=a
			r=b
		elif CLASS(a,Point) and CLASS(b,Point):
			P=a
			r=distance(a,b)
		else:
			raise Probleme("Arguments du constructeur d'un cercle")
		self.centre = copy(P)
		self.rayon  = copy(r)
	def point(self,t=0):
		return rotation(self.centre,
				t,
				Point(self.centre.x + self.rayon,
					self.centre.y))
	def tangente(self, P):
		return perpendiculaire(Droite(self.centre, P), P)
	def puissance(self, P):
		return (self.centre.x-P.x)*(self.centre.x-P.x) + (self.centre.y-P.y)*(self.centre.y-P.y) - self.rayon*self.rayon
	def trace(self, nom=None, position=None, style=None, couleur=None):
		OBJET.trace(self,nom, position, style, couleur)
		if not is_numeric(self.position):
			self.position = 0
		set_limits(Point(self.centre.x + self.rayon, self.centre.y))
		set_limits(Point(self.centre.x - self.rayon, self.centre.y))
		set_limits(Point(self.centre.x,              self.centre.y + self.rayon))
		set_limits(Point(self.centre.x,              self.centre.y - self.rayon))
		latex( "\\pscircle[linecolor=%s,linewidth=%s,linestyle=%s](%f,%f){%f}%%" % (self.color, linewidth(self.style), linestyle(self.style), self.centre.x, self.centre.y, self.rayon))
		x = self.centre.x + (self.rayon+0.5)*math.cos(self.position)
		y = self.centre.y + (self.rayon+0.5)*math.sin(self.position)
		if self.nom != None and self.nom != "":
			latex( "\\rput(%f,%f){$\\relax %s$}%%" % (x,y,self.nom))


######################################################################
class Arc(OBJET):
	def __init__(self, a=None, b=None, c=None, d=None):
		OBJET.__init__(self)
		if a==None and b==None:
			raise Erreur ("Non implment")
		# Le centre, le rayon et les deux angles (en radians) dlimitant l'arc
		elif CLASS(a,Point) and is_numeric(b) and is_numeric(c) and is_numeric(d):
			O = a
			A = translation(Vecteur(b*math.cos(c), b*math.sin(c)), a)
			B = rotation(O, d-c, A)
		# Le centre, une extrmit de l'arc et l'angle
		elif CLASS(a,Point) and CLASS(b,Point) and is_numeric(c) and d==None:
			O = a
			A = b
			B = rotation(O,c,A)
		# Le centre et deux points par lesquels passe l'arc
		elif CLASS(a,Point) and CLASS(b,Point) and CLASS(c,Point) and d==None:
			O = a
			A = b
			B = c
		else:
			raise Probleme("Arguments du constructeur d'un arc")
		self.centre         = copy(O)
		self.rayon          = distance(O,A)
		self.premier_angle  = angle( global_i, Vecteur(O,A) )
		self.deuxieme_angle = angle( global_i, Vecteur(O,B) )
		# Je veux que les deux angles soient dans [0, 2pi] et dans l'ordre croissant.
		# (a veut dire que le deuxime est dans [theta_1, theta_1 + 2pi].)
		self.premier_angle  = self.premier_angle  % (2*math.pi)
		self.deuxieme_angle = self.deuxieme_angle % (2*math.pi)	
		if self.deuxieme_angle < self.premier_angle:
			self.deuxieme_angle = self.deuxieme_angle + 2*math.pi
	def point(self,t=None): # t \in [0,1]
		if t==None:
			t = random()
		return rotation(self.centre,
				t*(self.premier_angle + self.deuxieme_angle )/2,
				Point(self.centre.x + self.rayon,
					self.centre.y))
	def trace(self, nom=None, position=None, style=None, couleur=None):
		OBJET.trace(self,nom, position, style, couleur)
		if not is_numeric(self.position):
			self.position = (self.premier_angle + self.deuxieme_angle )/2
		# Calcul des limites du dessin
		t = self.premier_angle
		u = self.deuxieme_angle
		if u >= 2*math.pi:
			set_limits(Point(self.centre.x + self.rayon, self.centre.y))
		if ( (t <= 0.5*math.pi and u >= math.pi/2) or u >= 2.5*math.pi):
        		set_limits(Point(self.centre.x,              self.centre.y + self.rayon))
		if ( t <= math.pi and u >= math.pi ) or u >= 3*math.pi:
			set_limits(Point(self.centre.x - self.rayon, self.centre.y))
		if (t <= 1.5*math.pi and u >= 1.5*math.pi) or u >= 3.5*math.pi:
			set_limits(Point(self.centre.x,              self.centre.y - self.rayon))
		set_limits(Point(self.centre.x + self.rayon*math.cos(t), self.centre.y + self.rayon*math.sin(t)))
		set_limits(Point(self.centre.x + self.rayon*math.cos(u), self.centre.y + self.rayon*math.sin(u)))
		latex( "\\psarc[linecolor=%s,linewidth=%s,linestyle=%s](%f,%f){%f}{%f}{%f}%%" % (self.color, linewidth(self.style), linestyle(self.style), self.centre.x, self.centre.y, self.rayon, self.premier_angle, self.deuxieme_angle))
		x = self.centre.x + (self.rayon+0.5)*math.cos(self.position)
		y = self.centre.y + (self.rayon+0.5)*math.sin(self.position)
		if self.nom != None and self.nom != "":
			latex( "\\rput(%f,%f){$\\relax %s$}%%" % (x,y,self.nom))


######################################################################

class Angle(OBJET):
	def __init__(self,A=None,O=None,B=None):
		OBJET.__init__(self)
		if A==None and O==None and B==None:
			O=Point()
			A=Cercle(O,1).point(2*math.pi*random())
			B=Cercle(O,1).point(2*math.pi*random())
		elif is_numeric(A) and O==None and B==None:
			alpha=A
			O=Point()
			A=Cercle(O,1).point(2*math.pi*random())
			B=rotation(O,alpha,A)
		elif CLASS(A,Point) and O==None and B==None:
			O=A
			A=Cercle(O,1).point(2*math.pi*random())
			B=Cercle(O,1).point(2*math.pi*random())
		elif CLASS(A,Point) and is_numeric(O) and B==None:
			alpha=O
			O=A
			A=Cercle(O,1).point(2*math.pi*random())
			B=rotation(O,alpha,A)
		elif CLASS(A,Point) and CLASS(O,Point) and B==None:
			B=Point()
		elif CLASS(A,Point) and CLASS(O,Point) and is_numeric(B):
			alpha=B
			B=O; O=A; A=B # J'intervertis O et A
			B=rotation(O,alpha,A)
		elif CLASS(A,Point) and CLASS(O,Vecteur) and CLASS(B,Vecteur):
			u=O; v=B; O=A
			A=translation(u,O)
			B=translation(v,O)
		elif CLASS(A,Point) and CLASS(O,Point) and CLASS(B,Point):
			pass
		else:
			raise("Probleme dans le constructeur d'un Angle")
		self.A = copy(A)
		self.B = copy(B)
		self.O = copy(O)
		self.angle = angle(Vecteur(O,A), Vecteur(O,B))
	def trace(self, nom=None, position=None, style=None, couleur=None):
		OBJET.trace(self, nom, position, style, couleur)
		#Segment(self.O,self.A).trace()
		#Segment(self.O,self.B).trace()
		set_limits(self.A); set_limits(self.O); set_limits(self.B); 
		latex( "\\psline[linecolor=%s,linestyle=%s,linewidth=%s](%f,%f)(%f,%f)(%f,%f)%%" %( self.color, linestyle(self.style), linewidth(self.style),self.A.x, self.A.y,
								     self.O.x, self.O.y,
								     self.B.x, self.B.y))
		a = angle(Vecteur(Point(0,0), Point(1,0)), Vecteur(self.O,self.A))
		b = angle(Vecteur(Point(0,0), Point(1,0)), Vecteur(self.O,self.B))
		if self.style == "simple" or self.style =="normal":
			latex( "\\psarc[linecolor=%s,linestyle=%s,linewidth=%s]{-}(%f,%f){%f}{%f}{%f}%%" % (self.color, linestyle(self.style), linewidth(self.style), self.O.x, self.O.y, 0.5, a, b))
		elif self.style == "double":
			latex("\\psarc[linecolor=%s,linestyle=%s,linewidth=%s]{-}(%f,%f){%f}{%f}{%f}%%" % (self.color, linestyle(self.style), linewidth(self.style), self.O.x, self.O.y, 0.5, a, b))
			latex("\\psarc[linecolor=%s,linestyle=%s,linewidth=%s]{-}(%f,%f){%f}{%f}{%f}%%" % (self.color, linestyle(self.style), linewidth(self.style), self.O.x, self.O.y, 0.4, a, b))
		elif self.style == "triple":
			latex("\\psarc[linecolor=%s,linestyle=%s,linewidth=%s]{-}(%f,%f){%f}{%f}{%f}%%" % (self.color, linestyle(self.style), linewidth(self.style), self.O.x, self.O.y, 0.5, a, b))
			latex("\\psarc[linecolor=%s,linestyle=%s,linewidth=%s]{-}(%f,%f){%f}{%f}{%f}%%" % (self.color, linestyle(self.style), linewidth(self.style), self.O.x, self.O.y, 0.4, a, b))
			latex("\\psarc[linecolor=%s,linestyle=%s,linewidth=%s]{-}(%f,%f){%f}{%f}{%f}%%" % (self.color, linestyle(self.style), linewidth(self.style), self.O.x, self.O.y, 0.6, a, b))
		elif self.style == "fleche":
			latex( "\\psarc[linecolor=%s,linestyle=%s,linewidth=%s]{->}(%f,%f){%f}{%f}{%f}%%" % (self.color, linestyle(self.style), linewidth(self.style), self.O.x, self.O.y, 0.5, a, b))
		elif self.style == "droit":
			A = translation(Vecteur(Point(0,0), Point(0.5/2*math.cos(a), 0.5/2*math.sin(a))), self.O)
			asdf = 0.5*math.sqrt(2)
			B = translation(Vecteur(Point(0,0), Point(asdf/2*math.cos((a+b)/2), asdf/2*math.sin((a+b)/2))), self.O)
			C = translation(Vecteur(Point(0,0), Point(0.5/2*math.cos(b), 0.5/2*math.sin(b))), self.O)
			#Segment(A,B).trace("", 0, "normal", couleur)
			#Segment(B,C).trace("", 0, "normal", couleur)
			latex( "\\psline[linecolor=%s,linestyle=%s,linewidth=%s](%f,%f)(%f,%f)(%f,%f)%%" %(self.color, linestyle(self.style), linewidth(self.style), A.x, A.y, B.x, B.y, C.x, C.y))
		else:
			#raise Probleme("STYLE")
			# PROBLME : ne tiens pas compte de ce qui a t lu par linestyle()
			pass
		x = self.O.x + 2*0.5*math.cos(a + (b-a)/2)
		y = self.O.y + 2*0.5*math.sin(a + (b-a)/2)
		if self.nom != None and self.nom != "":
			latex( "\\rput{0}(%f,%f){$\\relax %s$}%%" % (x,y, self.nom))

######################################################################

#class DemiDroite(OBJET):
#	def __init__(self, A, u):
#		OBJET.__init__(self)
#		

######################################################################

class Spline(OBJET):
	def __init__(self,points=None):
		# Prvoir de construire une courbe  partir 
		# d'un cercle, d'un arc ou d'un segment.
		#self.points = map(lambda a:A(a*0.05), range(0,20)):
		#self.points = map(lambda a:A(a*0.05*2*math.pi), range(0,20)):
		# Le  20  devrait tre un paramtre rglable
		# Une variable globale et un paramtre supplmentaire.
		OBJET.__init__(self)
		if points == None:
			points = map(lambda a: Point(), range(0,10))
		self.points = copy(points)
	def trace(self, nom=None, position=None, style=None, couleur=None):
		OBJET.trace(self, nom, position, style, couleur)
		latex( "\\pscurve[linewidth=%s,linecolor=%s,linestyle=%s]{-}%%" %(
			linewidth(self.style), self.color, linestyle(self.style)) )
		for P in self.points:
			set_limits(P)
			latex( "(%f,%f)%%" % (P.x, P.y))
		latex( "\\relax ")
		# Il faudrait mettre le nom de la courbe 
		# sur le dernier point (ou sur celui du milieu).
