##
## Quelques routines pour la gomtrie hyperbolique
##

def moebius(a,b,c,d,P):
	if CLASS(P,Point):
		Q = copy(P)
		Q.x = a*P.x + b*P.y
		Q.y = c*P.x + d*P.y
		return Q
	else:
		raise Erreur("Transformation de Moebius non implmente")

def disque_vers_demi_plan_hyperbolique(P):
	if CLASS(P,Point):
		d = (1+P.x)*(1+P.x)+P.y*P.y
		return Point( 2*P.y/d,
			      (1-P.x*P.x-P.y*P.y)/d
			    )
	else:
		raise Erreur("disque_vers_demi_plan_hyperbolique: uniquement des points pour l'instant")

def demi_plan_vers_disque_hyperbolique(P):
	if CLASS(P,Point):
		d=P.x*P.x+(1+P.y)*(1+P.y)
		return Point( (1-P.x*P.x-P.y*P.y)/d,
			      2*P.x/d)
	else:
		raise Erreur("demi_plan_vers_disque_hyperbolique: uniquement des points pour l'instant")


## Demi-plan hyperbolique

def geodesique_dans_le_demi_plan_hyperbolique(A,B):
	if zero(distance(A,B)):
		raise Erreur("Godsique : deux fois le mme point")
	elif zero(A.x - B.x):
		return Segment(A,B)
	else: # Il faudrait tenir compte des points  l'infini... ######
		O = intersection(mediatrice(A,B),
				 Droite(global_O, global_i))
		if(angle(Vecteur(O,A), Vecteur(O,B)) >= 0 ):
			return Arc(O,A,B)
		else:
			return Arc(O,B,A)


def reflexion_dans_le_demi_plan_hyperbolique(G,x):
	if CLASS(G,Droite) or CLASS(G,Segment):
		return symetrie_axiale(Droite(G.P, G.Q), x)
	else:
		A=demi_plan_vers_disque_hyperbolique(G.point(0.1))
		B=demi_plan_vers_disque_hyperbolique(G.point(0.9))
		y=demi_plan_vers_disque_hyperbolique(x)
		C=reflexion_dans_le_disque_hyperbolique(geodesique_dans_le_disque_hyperbolique(A,B),y)
		return disque_vers_demi_plan_hyperbolique(C)

def vieille_reflexion_dans_le_demi_plan_hyperbolique(G,x):
	if CLASS(G,Droite) or CLASS(G,Segment):
		return symetrie_axiale(Droite(G.P, G.Q), x)
	else:
		# On se ramne au cas prcdent
		# Prendre deux points sur la godsique
		A=G.point(0.1); B=G.point(1)
		A.trace("vert"); B.trace("vert")
		geodesique_dans_le_demi_plan_hyperbolique(A,B).trace("vert")
		(a,b)= solution_systeme(A.x, A.y, A.x, B.x, B.y, A.x)
		(c,d)= solution_systeme(A.x, A.y, A.y, -b, a, 1)
		AA=moebius(a,b,c,d,A)
		BB=moebius(a,b,c,d,B)
		geodesique_dans_le_demi_plan_hyperbolique(AA,BB).trace("bleu")
		MM=moebius(a,b,c,d,x)
		NN=symetrie_axiale(Droite(AA,BB), MM)
		geodesique_dans_le_demi_plan_hyperbolique(MM,NN).trace("bleu")
		N=moebius(d,-b,-c,a,NN)
		print a, b, c, d
		moebius(d,-b,-c,a,AA).trace()
		moebius(d,-b,-c,a,BB).trace()
		moebius(d,-b,-c,a,MM).trace()
		moebius(d,-b,-c,a,NN).trace()
		return N

def geodesique_dans_le_disque_hyperbolique(A,B):
	if zero(distance(Droite(A,B), global_O)):
		return Segment(A,B)
	else:
		(x1,y1) = solution_systeme(2*A.x, 2*A.y, 
					   1+(A.x*A.x+A.y*A.y)-0,
					   2*(A.x-B.x), 2*(A.y-B.y),
					   (A.x*A.x+A.y*A.y) - (B.x*B.x+B.y*B.y)
					   )
		P = Point(x1,y1)
		if angle(Vecteur(P,A), Vecteur(P,B)) < 0 :
			return Arc(P,B,A)
		else:
			return Arc(P,A,B)

def reflexion_dans_le_disque_hyperbolique(G,x):
	if CLASS(G,Droite):
		return symetrie_axiale(G,x)
	elif CLASS(G,Segment):
		D=Droite(G.P, G.Q)
		return symetrie_axiale(D,x)
	elif CLASS(G,Arc) or CLASS(G,Cercle):
		return inversion(G.centre, G.rayon*G.rayon, x)

